package com.biel.FastSurvival;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.Color;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.block.Chest;
import org.bukkit.entity.Damageable;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.inventory.EntityEquipment;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.LeatherArmorMeta;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.metadata.Metadatable;
import org.bukkit.potion.Potion;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionType;
import org.bukkit.util.Vector;

import Translations.LanguageStrings;

public class Utils {
	public static String L(String code){
		return LanguageStrings.getString(code);
	}
	public static ItemStack setItemNameAndLore(ItemStack item, String name, String... lore) {
		ItemMeta im = item.getItemMeta();
		if (!name.isEmpty()){im.setDisplayName(name);}
		im.setLore(Arrays.asList(lore));
		item.setItemMeta(im);
		return item;
	}
	public static ItemStack setItemName(ItemStack item, String name) {
		return setItemNameAndLore(item, name);
	}
	public static ItemStack setItemLore(ItemStack item, String... lore) {
		return setItemNameAndLore(item, "", lore);
	}
	public static void donarItem(Player p, Material mat, int quantitat, String name){
		Inventory inv = p.getInventory();
		ItemStack item = new ItemStack(mat, quantitat);
		if (!name.isEmpty()){
			ItemMeta meta = item.getItemMeta();
			meta.setDisplayName(name);
			item.setItemMeta(meta);
		}
		inv.addItem(item);
	}
	public static void donarItem(Player p, Material mat, String name){
		donarItem(p, mat, 1, name);
	}
	public static void donarItem(Player p, Material mat, int quantitat){
		donarItem(p, mat, quantitat, "");
	}
	public static void donarItem(Player p, Material mat){
		donarItem(p, mat, 1, "");
	}
	public static void donarItemsPlayer(Player ply, ArrayList<ItemStack> items){
		for(ItemStack item : items){
			giveItemStack(item, ply);
		}
	}
	public static void establirItem(Player p, Material mat, int slot, int quantitat){
		Inventory inv = p.getInventory();
		ItemStack item = new ItemStack(mat, quantitat);
		inv.setItem(slot, item);
	}
	public static void establirItem(Player p, Material mat, int slot){
		establirItem(p, mat, slot, 1);
	}
	public static int getArmorSlot(ItemStack itemstack){
		int slot = -1;
		String matstr = itemstack.getType().name();
		if(matstr.contains("HELMET")){
			slot = 3;
		}
		if(matstr.contains("CHESTPLATE")){
			slot = 2;
		}
		if(matstr.contains("LEGGINGS")){
			slot = 1;
		}
		if(matstr.contains("BOOTS")){
			slot = 0;
		}
		return slot;
	}
	public static ItemStack getItemInHand(LivingEntity l){
		if (l instanceof Player){
			return ((Player) l).getItemInHand();
		}
		EntityEquipment eq = l.getEquipment();
		if (eq != null){
			return eq.getItemInHand();
		}else{
			return null;
		}
	}
	public static boolean isArmor(ItemStack itemstack){
		int slot = getArmorSlot(itemstack);
		if(slot == -1){
			return false;
		}else{
			return true;
		}
	}
	public static void giveItemStack(ItemStack itemstack, Player d) {
		boolean isArmor = isArmor(itemstack);
		int slot = getArmorSlot(itemstack);

		if (isArmor){
			EstablirArmadura(d, itemstack, slot);
		}else{
			d.getInventory().addItem(itemstack);
		}


	}
	public static void EstablirArmadura(Player ply, ItemStack stack, int slot){
		ItemStack[] armor = ply.getInventory().getArmorContents();
		armor[slot] = stack;
		ply.getInventory().setArmorContents(armor);

	}
	public static void clearPlayers(ArrayList<Player> players){ 
		for (Player p : players){
			clearPlayer(p);
		}
	}
	public static void clearPlayer(Player ply){
		ply.getInventory().clear();
		clearEffects(ply);
		clearArmor(ply);
		ply.setGameMode(GameMode.SURVIVAL);
		ply.setHealth(ply.getMaxHealth());
		ply.setFireTicks(0);
		ply.setExp(0);
		ply.setLevel(0);
		ply.setFoodLevel(20);
		ply.setExhaustion(20);
		ply.setFallDistance(0);
	}
	public static void clearEffects(Player ply){
		for(PotionEffect effect : ply.getActivePotionEffects()){
			ply.removePotionEffect(effect.getType());
		}
	}
	public static void clearArmor(Player player){
		player.getInventory().setHelmet(null);
		player.getInventory().setChestplate(null);
		player.getInventory().setLeggings(null);
		player.getInventory().setBoots(null);
	}

	public static ItemStack createColoredArmor(Material part, Color color){
		ItemStack helm = new ItemStack(part);
		LeatherArmorMeta meta = (LeatherArmorMeta) helm.getItemMeta();
		meta.setColor(color);
		helm.setItemMeta(meta);
		return helm;
		//    	player.getInventory.setHelmet(helm);
	}
	public static int NombreEntre(int min, int max){
		return min + (int)(Math.random() * ((max - min) + 1));
	}
	public static boolean Possibilitat(int percentatge){
		int n = NombreEntre(0, 100);
		if (n <= percentatge){
			return true;
		}
		return false;

	}
	public static void healDamageable(Damageable d, Double amount){
		Double newAmount = d.getHealth() + amount;
		if (newAmount < 0){newAmount = 0D;}
		if (newAmount > d.getMaxHealth()){newAmount = d.getMaxHealth();}
		d.setHealth(newAmount);
	}
	public static void setMetadata(Metadatable object, String key, Object value){
		object.setMetadata(key, new FixedMetadataValue(FastSurvival.getPlugin(),value));
	}
	public static MetadataValue getMetadata(Metadatable object, String key){
		List<MetadataValue> values = object.getMetadata(key);  
		for (MetadataValue value : values) {
			// Plugins are singleton objects, so using == is safe here
			if (value.getOwningPlugin() == FastSurvival.getPlugin()) {
				return value;
			}
		}
		return null;
	}
	public static ArrayList<ItemStack> getInventoryPercent(Inventory inv, float percent){
		ArrayList<ItemStack> list = new ArrayList<ItemStack>();
		for (ItemStack i : inv.getContents()){
			if (i == null){continue;}
			if (Utils.Possibilitat((int) percent)){
				Material type = i.getType();
				int amount = (int) Math.floor(i.getAmount() * (percent / 100) * 2);
				ItemStack itemStack = i.clone();
				itemStack.setAmount(amount);
				list.add(itemStack);
			}
			
		}
		return list;
	}
	public static void BreakBlockLater(final Block block, int delay, final boolean give){
		Bukkit.getServer().getScheduler().scheduleSyncDelayedTask(FastSurvival.getPlugin(), new Runnable() {
			public void run() {
				if (give){
					block.breakNaturally();
				}else{
					block.setType(Material.AIR);
				}

			}
		}, delay);
	}

	public static Vector CrearVector(Location inici, Location fi){
		return fi.toVector().subtract(inici.toVector());
	}
	public static ArrayList<Location> getLocationsCircle(Location center, Double radius, int espai){
		return getLocationsCircle(center, radius, espai, 0, 360);
	}
	public static ArrayList<Location> getLocationsCircle(Location center, Double radius, int espai, int start, int end){
		ArrayList<Location> locs = new ArrayList<Location>();
		World world = center.getWorld();
		int i = start; //0

		while (i <= end){ // 360
			float angle = i;
			double toRadians = Math.PI / 180;
			//Location locSpawn = plyr.getLocation().add(0,1,0);
			Location spawnpoint = center.clone().add(new Location(world,Math.cos(angle * toRadians) * radius, 0, Math.sin(angle * toRadians) * radius));

			//Vector dir2 = spawnpoint.toVector().subtract(center.toVector()).normalize().multiply(0.5);
			locs.add(spawnpoint);
			i= i + espai;

		}
		return locs;
	}
	public static ArrayList<Location> getSphereLocations(Location center, Double radius, boolean hollow){
		ArrayList<Location> locs = new ArrayList<Location>();
		World world = center.getWorld();
		Cuboid c = getSquareCuboid(center, radius);
		for (Block b : c.getBlocks()){
			if (isInSphere(center, radius, b)){
				if (hollow){
					ArrayList<BlockFace> arr = new ArrayList<BlockFace>();
					arr.add(BlockFace.NORTH);
					arr.add(BlockFace.SOUTH);
					arr.add(BlockFace.EAST);
					arr.add(BlockFace.WEST);
					boolean valid = true;
					for (BlockFace face : arr){
						Block blk = b.getRelative(face);
						if (isInSphere(center, radius, b)){valid = false;}
					}
					if (valid == false){continue;}
				}
				locs.add(b.getLocation());
			}
		}
		return locs;
	}
	public static boolean isInSphere(Location center, Double radius, Block b) {
		return b.getLocation().distance(center) <= radius;
	}
	public static Cuboid getSquareCuboid(Location center, Double radius) {
		return new Cuboid(center.clone().subtract(radius, radius, radius), center.clone().add(radius, radius, radius));
	}
	public static ArrayList<LivingEntity> ordrerEnitiesByProximity(Location loc, ArrayList<LivingEntity> ents){
		ArrayList<LivingEntity> remaining = ents;
		ArrayList<LivingEntity> ordered = new ArrayList<LivingEntity>();
		while (remaining.size() > 0){
			LivingEntity nearestEntity = getNearestEntity(loc, ents);
			ordered.add(nearestEntity);
			remaining.remove(nearestEntity);
		}
		return ordered;
	}
	public static LivingEntity getNearestEntity(Location loc, ArrayList<LivingEntity> ents){
		if (ents.size() == 0){return null;}
		LivingEntity nearest = ents.get(0);
		double mindistance = nearest.getLocation().distance(loc);
		for (LivingEntity e : ents){
			double dist = e.getLocation().distance(loc);
			if (dist < mindistance){
				mindistance = dist;
				nearest = e;
			}
		}
		return nearest;
		
	}
	public static ArrayList<LivingEntity> getNearbyEnemies(LivingEntity entity, double dist, boolean lineSight){
		return getNearbyEnemies(entity, entity.getLocation(), dist, lineSight);
	}
	public static ArrayList<LivingEntity> getNearbyEnemies(LivingEntity entity, Location center , double dist, boolean lineSight){
		ArrayList<LivingEntity> ents = new ArrayList<LivingEntity>();
		World world = entity.getWorld();
		//Bukkit.broadcastMessage(Integer.toString(world.getEntities().size()));
		for(Entity e : world.getEntitiesByClass(LivingEntity.class)){
			if (!(e instanceof LivingEntity)){break;}			
			LivingEntity le = (LivingEntity) e;
			if(le.getLocation().distance(center) <= dist){
				if(lineSight){if(!le.hasLineOfSight(entity)){continue;}}
				if(le.equals(entity)){continue;}
				ents.add(le);
			}
		}
		//Bukkit.broadcastMessage(Integer.toString(ents.size()));
		return ents;
	}
	public static ArrayList<Player> getNearbyPlayers(Player p, double dist, boolean equips, boolean onlyEnemies){
		ArrayList<Player> players = new ArrayList<Player>();
		for (Player ply : p.getWorld().getPlayers()){
			if(!ply.getName().equals(p.getName())){
				Location ploc = ply.getLocation();
				if (ploc.distance(p.getLocation()) <= dist){

					players.add(ply);
				}
			}
		}
		return players;
	}
	public static Entity getEntityFromUUID(UUID id, World w){
		for(Entity e : w.getEntities()){
			if(e.getUniqueId() == id){
				return e;
			}
		}
		return null;
	}
	public static Entity getEntityFromUUID(UUID id){
		for (World w : Bukkit.getWorlds()){
			Entity entityFromUUID = getEntityFromUUID(id, w);
			if (entityFromUUID != null){
				return entityFromUUID;
			}
		}
		return null;
	}
	public static Cuboid getCuboidAround(Location loc, int x, int y, int z){
		return new Cuboid(loc.getWorld(), loc.getBlockX() - x, loc.getBlockY() - y, loc.getBlockZ() - z, loc.getBlockX() + x, loc.getBlockY() + y, loc.getBlockZ() + z);
	}
	public static Cuboid getCuboidAround(Location loc, int r){
		return getCuboidAround(loc, r, r, r);
	}
	public static ArrayList<Block> getCylBlocks(Location loc, int r, int height, Boolean fill){
		ArrayList<Block> blks = new ArrayList<Block>();
		int heightDone = 0;
		while(heightDone < height){
			Location center = loc.clone().add(new Vector(0,heightDone,0));
			Cuboid c = getCuboidAround(center, r, 0, r);
			for (Block b : c.getBlocks()){
				double dist = b.getLocation().distance(center);
				Boolean isValid = true;
				if (fill == true){isValid = (dist <= r);}
				if (fill == false){isValid = (dist == r);}
				if (isValid){
					//b.setType(mat);
					blks.add(b);
				}
			}
			heightDone++;
		}
		return blks;
	}
	public static ArrayList<Block> getOuterCylBlocks(Location loc, int r, int height, Boolean fill){
		ArrayList<Block> cylBlocks = getCylBlocks(loc, r, height, true);
		int newR = r - 1;
		if (newR >= 0){
			cylBlocks.removeAll(getCylBlocks(loc, newR, height, true));
		}
		
		return cylBlocks;
		
	}
	public static void fillChestRandomly(Block chest, ArrayList<ItemStack> it){
		if (chest == null){return;}
		if (chest.getType() != Material.CHEST){return;}
		Chest ch = (Chest) chest.getState();
		for (ItemStack i : it){
			int slot = Utils.NombreEntre(0, ch.getInventory().getSize() - 1);
			ch.getInventory().setItem(slot, i);
			
		}
	}
	public static PotionType getRandomPotionType(){
		return PotionType.values()[Utils.NombreEntre(0, PotionType.values().length - 1)];
	}
	public static ItemStack getRandomPotion(){
		Potion p = new Potion(getRandomPotionType());
		if (Utils.Possibilitat(55)){p.setSplash(true);}
		//p.setLevel(1);
		return p.toItemStack(1);
	}
	public static ArrayList<ItemStack> getBrewingItems(){
		ArrayList<ItemStack> i = new ArrayList<ItemStack>();
		i.add(new ItemStack(Material.NETHER_WARTS));
		i.add(new ItemStack(Material.GLOWSTONE));
		i.add(new ItemStack(Material.REDSTONE));
		i.add(new ItemStack(Material.SPIDER_EYE));
		i.add(new ItemStack(Material.MAGMA_CREAM));
		i.add(new ItemStack(Material.BLAZE_POWDER));
		i.add(new ItemStack(Material.SUGAR));
		i.add(new ItemStack(Material.GHAST_TEAR));
		i.add(new ItemStack(Material.GOLDEN_CARROT));
		return i;
	}
	
}
